/*
 * CameraPositionData.h
 *
 *  Created on: Apr 10, 2010
 *      Author: lziegler
 */

#ifndef CAMERAPOSITIONDATA_H_
#define CAMERAPOSITIONDATA_H_

#include "Type.h"

namespace airobots {

class CameraPositionData: public Type {

public:

	static std::string getBaseTag();

	static std::string getTemplate();

	CameraPositionData();

	/**
	 * Returns the horizontal angle value as radiant for the new position.
	 */
	double getPan() const;
	void setPan(double pan);

	/**
	 * Returns the vertical angle value as radiant for the new position.
	 */
	double getTilt() const;
	void setTilt(double tilt);

	/**
	 * Returns the desired zoom level as percent of the maximum zoom of the
	 * camera [0,1].
	 */
	double getZoom() const;
	void setZoom(double zoom);

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, CameraPositionData &type);

private:

	double pan;
	double tilt;

	double zoom;

};

}

#endif /* CAMERAPOSITIONDATA_H_ */
