#ifndef FACELIST_H_
#define FACELIST_H_

#include "Type.h"
#include "Face.h"
#include <vector>
#include <string>

namespace airobots {

class FaceList: public Type {
public:
	FaceList();
	virtual ~FaceList();

	static std::string getBaseTag();
	static std::string getTemplate();

	void sanitizeLocation(xmltio::Location & loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, FaceList &type);

	void addFace(Face face);
	std::vector<Face> getFaces();

private:
	std::vector<Face> faces;
};

}

#endif /* FACELIST_H_ */
