#ifndef GLOBALPLAN_H_
#define GLOBALPLAN_H_

#include <string>
#include <list>

#include <xmltio/xmltio.hpp>

#include "Type.h"
#include "NavigationGoalData.h"

namespace airobots {

/**
 * A list of waypoints that make up a plan from a global planner.
 *
 * @author jwienke
 */
class GlobalPlan: public Type {

private:
	std::list<NavigationGoalData> waypoints;

public:

	static std::string getBaseTag();

	static std::string getTemplate();

	GlobalPlan();
	GlobalPlan(std::string generator);

	void addWaypoint(const NavigationGoalData waypoint);
	void removeLastWayoint();
	std::list<NavigationGoalData>::const_iterator begin() const;
	std::list<NavigationGoalData>::const_iterator end() const;
	void clear();
	size_t size() const;
	bool empty() const;

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, GlobalPlan &type);

};

}

#endif /* WAYPOINTLIST_H_ */
