/* -*- mode: C++; tab-width: 4; c-basic-offset: 4; c-file-offsets: ((substatement-open . 0)) -*- */

#include <sstream>
#include <stdlib.h>

#include "GoalReachedData.h"

using namespace std;
using namespace xmltio;
using namespace airobots;

std::string GoalReachedData::getBaseTag() {
	return "GOALREACHED";
}

std::string GoalReachedData::getTemplate() {
	return std::string("<" + getBaseTag() + ">") + "<GENERATOR/>"
			+ Timestamp::getTemplate() + "<REACHED/>" + "</" + getBaseTag()
			+ ">";
}

GoalReachedData::GoalReachedData() {
}

GoalReachedData::GoalReachedData(string generator, bool goalReached) :
	Type(generator), goalReached(goalReached) {
}

void GoalReachedData::setGoalReached(bool reached) {
	this->goalReached = reached;
}

bool GoalReachedData::isGoalReached() const {
	return goalReached;
}

void GoalReachedData::sanitizeLocation(xmltio::Location &loc) const {
	
}

void GoalReachedData::fillInto(xmltio::Location &loc) const {

	Type::fillInto(loc);

	loc[XPath("REACHED")] = isGoalReached() ? 1 : 0;

}

void GoalReachedData::fromLocation(const xmltio::Location &loc_, GoalReachedData &grd) {

	Type::fromLocation(loc_, grd);

	grd.setGoalReached(extract<int> (loc_[XPath("REACHED")]));

}

