#ifndef GOALREACHEDDATA_HPP
#define GOALREACHEDDATA_HPP

#include <stdio.h>
#include <string>

#include <xmltio/xmltio.hpp>

#include "Type.h"

namespace airobots {

class GoalReachedData: public Type {
public:

	static std::string getBaseTag();

	static std::string getTemplate();

	GoalReachedData();
	GoalReachedData(std::string generator, bool goalReached);

	void setGoalReached(bool reached);
	bool isGoalReached() const;

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, GoalReachedData &type);

private:
	/**
	 * 0=not reached, 1=reached
	 */
	bool goalReached;

};

}

#endif
