/*
 * KatanaPoseData.h
 *
 *  Created on: May 25, 2010
 *      Author: ttoenige
 */

#ifndef KATANAPOSEDATA_H_
#define KATANAPOSEDATA_H_

#include "Type.h"
namespace airobots
{

class KatanaPoseData: public Type
{
public:
	static std::string getBaseTag();

	static std::string getTemplate();

	/**
	 * Returns the x-value of the endeffector position (mm)
	 */
	double getX() const;
	void setX(double x);

	/**
	 * Returns the y-value of the endeffector position (mm)
	 */
	double getY() const;
	void setY(double y);

	/**
	 * Returns the z-value of the endeffector position (mm)
	 */
	double getZ() const;
	void setZ(double z);

	/**
	 * Returns the phi-value of the endeffector position (rad)
	 */
	double getPhi() const;
	void setPhi(double phi);

	/**
	 * Returns the psi-value of the endeffector position (rad)
	 */
	double getPsi() const;
	void setPsi(double psi);

	/**
	 * Returns the theta-value of the endeffector position (rad)
	 */
	double getTheta() const;
	void setTheta(double theta);

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, KatanaPoseData &type);

	KatanaPoseData();

private:
	double x;
	double y;
	double z;
	double theta;
	double phi;
	double psi;
};

}

#endif /* KATANAPOSEDATA_H_ */
