/*
 * Legs.cpp
 *
 *  Created on: Aug 18, 2009
 *      Author: jwienke
 */

#include "Legs.h"

#include <iostream>

using namespace std;
using namespace xmltio;
using namespace airobots;

Legs::Legs() {
}

Legs::~Legs() {
}

std::string Legs::getBaseTag() {
	return "LEGS";
}

std::string Legs::getTemplate() {
	return string("<") + getBaseTag() + ">" + "<GENERATOR/>"
			+ Timestamp::getTemplate()
			+ "<POSITION angle=\"\" angleVariance=\"\" distance=\"\" distanceVariance=\"\" />"
			+ "<SHARING nrInvolved=\"\" involved1=\"\" involved2=\"\" isPair=\"\"/>"
			+ "</LEGS>";
}

std::string Legs::getPerceptName() {
	return "legs";
}

float Legs::getAngle() const {
	return this->angle;
}

void Legs::setAngle(float angle) {
	this->angle = angle;
}

float Legs::getDistance() const {
	return this->distance;
}

void Legs::setDistance(float distance) {
	this->distance = distance;
}

float Legs::getAngleVariance() const {
	return angleVariance;
}

void Legs::setAngleVariance(float angleVariance) {
	this->angleVariance = angleVariance;
}

float Legs::getDistanceVariance() const {
	return distanceVariance;
}

void Legs::setDistanceVariance(float distanceVariance) {
	this->distanceVariance = distanceVariance;
}

int Legs::getNumInvovled() const {
	return numInvolved;
}

void Legs::setNumInvolved(int numInvovled) {
	this->numInvolved = numInvovled;
}

int Legs::getInvolved1() const {
	return involved[0];
}

void Legs::setInvolved1(int involved) {
	this->involved[0] = involved;
}

int Legs::getInvolved2() const {
	return involved[1];
}

void Legs::setInvolved2(int involved) {
	this->involved[1] = involved;
}

bool Legs::isPair() const {
	return pair;
}

void Legs::setPair(bool isPair) {
	this->pair = isPair;
}

bool Legs::operator==(const Legs &other) const {
	return Type::operator==(other) && (other.angle == angle) && (other.distance
			== distance) && (other.angleVariance == angleVariance)
			&& (other.distanceVariance == distanceVariance)
			&& (other.involved[0] == involved[0]) && (other.involved[1]
			== involved[1]) && (other.numInvolved == numInvolved)
			&& (other.pair == pair);
}

std::ostream& airobots::operator<<(std::ostream& o, Legs const& legs) {
	return o << "Legs [angle = " << legs.getAngle() << ", angleVariance = "
			<< legs.getAngleVariance() << ", distance = " << legs.getDistance()
			<< ", distanceVariance = " << legs.getDistanceVariance()
			<< ", numInvolved = " << legs.getNumInvovled() << ", involdved1 = "
			<< legs.getInvolved1() << ", involved2 = " << legs.getInvolved2()
			<< ", isPair = " << legs.isPair() << "]";
}

void Legs::sanitizeLocation(xmltio::Location &loc) const {
	
}

void Legs::fillInto(xmltio::Location &loc) const {

	Type::fillInto(loc);

	loc[XPath("POSITION/@angle")] = getAngle();
	loc[XPath("POSITION/@angleVariance")] = getAngleVariance();
	loc[XPath("POSITION/@distance")] = getDistance();
	loc[XPath("POSITION/@distanceVariance")] = getDistanceVariance();

	loc[XPath("SHARING/@nrInvolved")] = getNumInvovled();
	loc[XPath("SHARING/@involved1")] = getInvolved1();
	loc[XPath("SHARING/@involved2")] = getInvolved2();
	loc[XPath("SHARING/@isPair")] = isPair();

}

void Legs::fromLocation(const xmltio::Location &loc_, Legs &legs) {

	Type::fromLocation(loc_, legs);

	legs.setAngle(extract<float> (loc_[XPath("POSITION/@angle")]));
	legs.setAngleVariance(extract<float> (
			loc_[XPath("POSITION/@angleVariance")]));
	legs.setDistance(extract<float> (loc_[XPath("POSITION/@distance")]));
	legs.setDistanceVariance(extract<float> (loc_[XPath(
			"POSITION/@distanceVariance")]));

	legs.setNumInvolved(extract<int> (loc_[XPath("SHARING/@nrInvolved")]));
	legs.setInvolved1(extract<int> (loc_[XPath("SHARING/@involved1")]));
	legs.setInvolved2(extract<int> (loc_[XPath("SHARING/@involved2")]));
	legs.setPair(extract<int> (loc_[XPath("SHARING/@isPair")]));

}
