/*
 * Legs.h
 *
 *  Created on: Aug 18, 2009
 *      Author: jwienke
 */

#ifndef LEGS_H_
#define LEGS_H_

#include "Type.h"
#include "Percept.h"

namespace airobots {

/**
 * Leg percept.
 *
 * @author jwienke
 */
class Legs: public Percept {

public:

	static std::string getBaseTag();
	static std::string getTemplate();
	static std::string getPerceptName();

	Legs();
	virtual ~Legs();

	float getAngle() const;
	void setAngle(float angle);

	float getDistance() const;
	void setDistance(float distance);

	float getAngleVariance() const;
	void setAngleVariance(float angleVariance);

	float getDistanceVariance() const;
	void setDistanceVariance(float distanceVariance);

	int getNumInvovled() const;
	void setNumInvolved(int numInvovled);

	int getInvolved1() const;
	void setInvolved1(int involved);

	int getInvolved2() const;
	void setInvolved2(int involved);

	bool isPair() const;
	void setPair(bool isPair);

	bool operator==(const Legs &other) const;

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, Legs &type);

private:

	float angle;
	float distance;
	float angleVariance;
	float distanceVariance;
	int numInvolved;
	int involved[2];
	bool pair;

};

std::ostream& operator<<(std::ostream& o, Legs const& legs);

}

#endif /* LEGS_H_ */
