/*
 * MapArea.h
 *
 *  Created on: Oct 27, 2010
 *      Author: ltwardon
 */

#ifndef MAPAREA_H_
#define MAPAREA_H_

#include <string>
#include <list>
#include "MapRegion.h"

namespace airobots {

class MapArea {

public:

	enum MapAreaType {
		NOGO,
		ROOM,
		INTEREST,
		PERSON,
		DISTURB,
		OBJECTS,
		NO_TYP
	};

	static const std::string mapAreaTypeValue[];

	MapArea();
	MapArea(MapAreaType type);
	MapArea(MapAreaType type, std::string arenaName, std::list<MapRegion> regions);

	void addRegion(MapRegion region);
	MapAreaType getType() const;
	void setType(MapAreaType type);
	std::string getArenaName() const;
	void setArenaName(std::string arenaName);
	std::list<MapRegion> getRegions() const;
	void setRegions(std::list<MapRegion> regions);
	void removeRegion(std::string regionLabel);
	MapRegion getRegionByLabel(std::string regionLabel) const;
	std::list<MapRegion> getRegionByGroup(std::string group) const;

private:

	std::string arenaName;
	MapAreaType type;
	std::list<MapRegion> regions;

	bool checkRegionLabel(std::string region);
	std::string createNewLabel(MapRegion region);

};

}

#endif /* MAPAREA_H_ */
