#include "ObjectLocationList.h"

using namespace xmltio;
using namespace airobots;
using namespace std;

std::string ObjectLocationList::getBaseTag() {
	return "OBJECTLOCATIONLIST";
}

std::string ObjectLocationList::getTemplate() {
	return "<" + getBaseTag() + "></" + getBaseTag() + ">";
}

ObjectLocationList::ObjectLocationList() :
	Type() {
}

ObjectLocationList::ObjectLocationList(std::string generator) :
	Type(generator) {
}

void ObjectLocationList::sanitizeLocation(xmltio::Location &loc) const {
	XPath xp(ObjectLocationData::getBaseTag());
	while (XPathIterator i = xp.evaluate(loc)) {
		Location l(*i);
		loc.remove(l);
	}
}

void ObjectLocationList::fillInto(xmltio::Location &loc) const {

	for (vector<ObjectLocationData>::const_iterator it = this->begin(); it
			!= this->end(); it++) {

		Location obj(ObjectLocationData::getTemplate(), XPath(
				ObjectLocationData::getBaseTag()));

		it->fillInto(obj);
		loc.add(obj);
	}
}

void ObjectLocationList::fromLocation(const xmltio::Location &loc_,
		ObjectLocationList &object) {

	for (XPathIterator iter = XPath(ObjectLocationData::getBaseTag()).evaluate(
			loc_); iter; ++iter) {
		Location l(*iter);
		ObjectLocationData data = extract<ObjectLocationData> (l);
		object.push_back(data);
	}
}

bool ObjectLocationList::operator==(const ObjectLocationList &other) const {

	bool isSame = size() == other.size();
	if (isSame) {
		for (unsigned int i = 0; i < size(); i++) {
			if (!(this->at(i) == other[i])) {
				isSame = false;
			}
		}
	}
	return isSame;
}
