 /** ==========================================================================
 * 
 * @file		PersonDataList.h --
 * @brief		Header file for the list of person data.
 *
 * @author	Denis Schulze <dschulze@techfak.uni-bielefeld.de>
 * 
 * ========================================================================== 
 **/

#ifndef __PERSONDATALIST_H__
#define __PERSONDATALIST_H__

#include <vector>

#include "Type.h"
#include "PersonData.h"

namespace airobots {

class PersonDataList : public Type {

	public:

		/** Constructor. */
		PersonDataList();

		/** Deconstructor. */
		~PersonDataList();

		static std::string getBaseTag();
		
		static std::string getTemplate();

		void addPersonData(airobots::PersonData data);

		std::vector<PersonData> getPersonData();

		int size();

		void sanitizeLocation(xmltio::Location &loc) const;
		void fillInto(xmltio::Location &loc) const;
		static void fromLocation(const xmltio::Location &loc, PersonDataList &list);
	
	private:

		/** A list of all stored person data in this list. */
		std::vector<PersonData> personData;		

};

}

#endif /* __PERSONDATALIST_H__ */
