/*
 * Point3D.h
 *
 *  Created on: Jun 4, 2010
 *      Author: lziegler
 */

#ifndef POINT3D_H_
#define POINT3D_H_

#include <xmltio/xmltio.hpp>
#include "Type.h"
#include "UnitConverter.h"

namespace airobots {

class Point3D : public Type {
public:
	enum Scope {
		GLOBAL, LOCAL
	};

	Point3D();
	Point3D(float x, float y, float z, LengthUnit unit);
	Point3D(float x, float y, float z, LengthUnit unit, Point3D::Scope scope);
	virtual ~Point3D();

	static std::string getBaseTag();
	static std::string getTemplate();

	Point3D::Scope getScope() const;
	float getX(LengthUnit unit = MILLIMETER) const;
	float getY(LengthUnit unit = MILLIMETER) const;
	float getZ(LengthUnit unit = MILLIMETER) const;
	void setScope(Point3D::Scope scope);
	void setX(float x, LengthUnit unit);
	void setY(float y, LengthUnit unit);
	void setZ(float z, LengthUnit unit);

	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, Point3D &type);
	void sanitizeLocation(xmltio::Location &loc) const;

private:
	float x;
	float y;
	float z;
	Point3D::Scope scope;
};

}

#endif /* POINT3D_H_ */
