#ifndef POLYGON_H_
#define POLYGON_H_

#include <vector>
#include "Type.h"

using namespace std;

namespace airobots {

class Polygon : public Type {
public:
	struct Point2D {
		Point2D() {};
		Point2D(int x, int y) : x(x), y(y) {};
		int x, y;
	};

	Polygon();
	virtual ~Polygon();

	static std::string getBaseTag();
	static std::string getItemTag();
	static std::string getTemplate();

	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, Polygon &pol);
	void sanitizeLocation(xmltio::Location &loc) const;

	virtual bool operator==(const Polygon &other) const;

	void addPoint(Point2D p);
	Point2D getCentroid();

	vector<Point2D> getPoints();

private:
	vector<Point2D> points;
};

}

#endif /* POLYGON_H_ */
