/*
 * PoseData.h
 *
 *  Created on: May 25, 2010
 *      Author: ttoenige
 */

#ifndef POSEDATA_H_
#define POSEDATA_H_

#include "Type.h"
namespace airobots
{

class PoseData: public Type
{
public:
	static std::string getBaseTag();

	static std::string getTemplate();

	/**
	 * Returns the x-value of the endeffector position (mm)
	 */
	double getX() const;
	void setX(double x);

	/**
	 * Returns the y-value of the endeffector position (mm)
	 */
	double getY() const;
	void setY(double y);

	/**
	 * Returns the z-value of the endeffector position (mm)
	 */
	double getZ() const;
	void setZ(double z);


	void sanitizeLocation(xmltio::Location &loc) const;
	virtual void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, PoseData &type);

	PoseData();

private:
	double x;
	double y;
	double z;
	double theta;
	double phi;
	double psi;
};

}

#endif /* POSEDATA_H_ */
