/*
 * PositionData.cpp
 *
 *  Created on: Jul 31, 2009
 *      Author: jwienke
 */

#include "PositionData.h"

using namespace std;
using namespace airobots;
using namespace xmltio;

namespace airobots {

std::string PositionData::getBaseTag() {
	return "ROBOTPOSITION";
}

std::string PositionData::getTemplate() {

	return "<" + getBaseTag() + ">"
		+ "<GENERATOR/>"
		+ airobots::Timestamp::getTemplate()
		+ "<POSITION ref=\"world\" kind=\"absolute\" x=\"\" y=\"\" theta=\"\" />"
		+ "</" + getBaseTag() + ">";

}

PositionData::PositionData() :
	x(0), y(0), theta(0) {

}

PositionData::PositionData(float x, float y, float theta) :
	x(x), y(y), theta(theta) {

}

PositionData::~PositionData() {
}

float PositionData::getX() const {
	return x;
}

void PositionData::setX(float x) {
	this->x = x;
}

float PositionData::getY() const {
	return y;
}

void PositionData::setY(float y) {
	this->y = y;
}

float PositionData::getTheta() const {
	return theta;
}

void PositionData::setTheta(float theta) {
	this->theta = theta;
}

void PositionData::sanitizeLocation(xmltio::Location &loc) const {

}

void PositionData::fillInto(xmltio::Location &loc) const {

	Type::fillInto(loc);

	loc[XPath("POSITION/@x")] = getX();
	loc[XPath("POSITION/@y")] = getY();
	loc[XPath("POSITION/@theta")] = getTheta();

}

void PositionData::fromLocation(const xmltio::Location &loc_, PositionData &pos) {

	Type::fromLocation(loc_, pos);

	pos.setX(extract<float> (loc_[XPath("POSITION/@x")]));
	pos.setY(extract<float> (loc_[XPath("POSITION/@y")]));
	pos.setTheta(extract<float> (loc_[XPath("POSITION/@theta")]));

}

}
