#ifndef PRECISEPOLYGON_H_
#define PRECISEPOLYGON_H_

#include "Type.h"
#include "Point2D.h"
#include "UnitConverter.h"

#include <vector>

namespace airobots {

class PrecisePolygon : public Type {

public:

	PrecisePolygon();
	PrecisePolygon(const PrecisePolygon &poly);
	virtual ~PrecisePolygon();

	static std::string getBaseTag();
	static std::string getTemplate();

	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, PrecisePolygon &pol);
	void sanitizeLocation(xmltio::Location &loc) const;

	virtual bool operator==(const PrecisePolygon &other) const;

	void addPoint(double x, double y, LengthUnit unit);
	void addPoint(Point2D point);

	Point2D getCentroid();
	std::vector<Point2D> getPoints() const;

//	double getMinX(/*LengthUnit unit*/);
//	double getMaxX(/*LengthUnit unit*/);
//	double getMinY(/*LengthUnit unit*/);
//	double getMaxY(/*LengthUnit unit*/);
//	double getArea(/*LengthUnit unit*/);
//
//	void move(double dx, double dy/*, LengthUnit unit*/);
//	void scale(double factor);
//	void rotate(Point2D center, double angle/*, AngleUnit unit*/);
//	void rotate(double x, double y/*, LengthUnit lengthunit*/, double angle/*, AngleUnit angleUnit*/);
//
//	bool contains(double x, double y/*, LengthUnit unit*/);
//	bool contains(Point2D p);

	// generatePath, updateFromPath

protected:

	std::vector<Point2D> list;

};

}

#endif /* PRECISEPOLYGON_H_ */
