#ifndef REGIONDATA_H_
#define REGIONDATA_H_

#include <string>
#include <vector>
#include <list>

#include <xmltio/xmltio.hpp>

#include "Type.h"
#include "UnitConverter.h"
#include "PrecisePolygon.h"

namespace airobots {

/**
 * Results of the object recognition.
 *
 * @author lziegler
 */
class RegionData: public Type {

public:

	enum Scope {
		LOCAL, GLOBAL
	};
	Scope scope;

	//std::vector<std::pair<double, double> > polygon;
	PrecisePolygon polygon;
	std::vector<std::pair<double, double> > scalePolygon(std::vector<std::pair<
			double, double> > poly, double factor) const;

public:

	static std::string getBaseTag();
	static std::string getTemplate();

	std::vector<std::pair<double, double> > getPolygon(LengthUnit unit) const;
	void setPolygon(const std::vector<std::pair<double, double> > &polygon,
			LengthUnit unit);

	PrecisePolygon getPolygon() const;
	void setPolygon(PrecisePolygon poly);

	void setScope(const Scope &scope);
	Scope getScope() const;

	virtual bool operator==(const RegionData &other) const;

	void sanitizeLocation(xmltio::Location&) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, RegionData &type);

	RegionData();
	RegionData(std::string generator);
};

}

#endif /* REGIONDATA_H_ */
