#include "SRPlaceData.h"

using namespace xmltio;
using namespace airobots;
using namespace std;

SRPlaceData::SRPlaceData() {
}

SRPlaceData::SRPlaceData(std::string lable, double confidence, Timestamp ts) {
	srPlaceLabel = lable;
	srPlaceConfidence = confidence;
	srPlaceTimeStamp = ts;
}

SRPlaceData::~SRPlaceData() {
}

const Timestamp SRPlaceData::getSrPlaceTimeStamp() const
{
	return srPlaceTimeStamp;
}



void SRPlaceData::setSrPlaceLabel(std::string lable)
{
	srPlaceLabel = lable;
}



void SRPlaceData::sanitizeLocation(xmltio::Location & loc) const
{
}



std::string SRPlaceData::getTemplate()
{
	return "<" + getBaseTag() + " label=\"\" confidence=\"\"><GENERATOR/>" + Timestamp::getTemplate()+ "</" + getBaseTag() + ">";
}



const std::string SRPlaceData::getSrPlaceLabel() const
{
	return srPlaceLabel;
}



const double SRPlaceData::getSrPlaceConfidence() const
{
	return srPlaceConfidence;
}



void SRPlaceData::setSrPlaceConfidence(double confidence)
{
	srPlaceConfidence = confidence;
}



void SRPlaceData::setSrPlaceTimeStamp(Timestamp timestamp)
{
	srPlaceTimeStamp = timestamp;
}



void SRPlaceData::fillInto(xmltio::Location & loc) const
{
	Type::fillInto(loc);

	loc[XPath("@label")] = getSrPlaceLabel();
	loc[XPath("@confidence")] = getSrPlaceConfidence();
	loc[XPath(Timestamp::getBaseTag())] = getTimestamp();
}



std::string SRPlaceData::getBaseTag()
{
	return "SRPLACEDATA";
}



void SRPlaceData::fromLocation(const xmltio::Location & loc, SRPlaceData & type)
{
	Type::fromLocation(loc, type);
	type.setSrPlaceLabel(extract<string>(loc[XPath("@label")]));
	type.setSrPlaceConfidence(extract<double>(loc[XPath("@confidence")]));
}


