#ifndef SRPLACEDATA_H_
#define SRPLACEDATA_H_

#include "Type.h"
#include <string>

namespace airobots {

class SRPlaceData: public Type {
public:
	SRPlaceData();
	SRPlaceData(std::string lable, double confidence, Timestamp ts);
	virtual ~SRPlaceData();

	static std::string getBaseTag();
	static std::string getTemplate();

	void sanitizeLocation(xmltio::Location &loc) const;
	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, SRPlaceData &type);

	const double getSrPlaceConfidence() const;
	const std::string getSrPlaceLabel() const;
	const Timestamp getSrPlaceTimeStamp() const;

	void setSrPlaceConfidence(double confidence);
	void setSrPlaceLabel(std::string lable);
	void setSrPlaceTimeStamp(Timestamp timestamp);

private:
	std::string srPlaceLabel;
	double srPlaceConfidence;
	Timestamp srPlaceTimeStamp;
};

}

#endif /* SRPLACEDATA_H_ */
