#ifndef STATECHANGEREQUEST_H_
#define STATECHANGEREQUEST_H_

#include "Type.h"
#include <string>

namespace airobots {

class StateChangeRequest: public Type {

public:

	StateChangeRequest();
	virtual ~StateChangeRequest();

	static std::string getBaseTag();
	static std::string getTemplate();

	void fillInto(xmltio::Location &loc) const;
	static void fromLocation(const xmltio::Location &loc, StateChangeRequest &pol);
	void sanitizeLocation(xmltio::Location &loc) const;

	const std::string getNewStateName() const;
	void setNewStateName(std::string name);


private:

	static const std::string STATE_ELEMENT;
	std::string newStateName;
};

}

#endif /* STATECHANGEREQUEST_H_ */
