#include <boost/test/unit_test.hpp>
#include <boost/test/floating_point_comparison.hpp>

#include <iostream>

#include "btl/ImageData.h"
#include "utils.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

static const double TOLERANCE = 0.0001;

BOOST_AUTO_TEST_SUITE(ImageDataTest)

BOOST_AUTO_TEST_CASE(testFileCompatibility) {

	Location fileContents(readFile("ImageData.xml"), ImageData::getBaseTag());
	ImageData parsed = extract<ImageData>(fileContents);

	BOOST_REQUIRE_EQUAL("test", parsed.getGenerator());
	BOOST_REQUIRE_EQUAL(215815152l, parsed.getTimestamp().getInserted());
	BOOST_REQUIRE_EQUAL(215815152l, parsed.getTimestamp().getUpdated());
	BOOST_REQUIRE_EQUAL(320, parsed.getWidth());
	BOOST_REQUIRE_EQUAL(240, parsed.getHeight());
	BOOST_REQUIRE_EQUAL("rgb", parsed.getColorspace());

}

BOOST_AUTO_TEST_SUITE_END()
