#include <boost/test/unit_test.hpp>
#include <boost/test/floating_point_comparison.hpp>

#include <iostream>

#include <sys/time.h>
#include <time.h>

#include "btl/SRPlaceData.h"
#include "utils.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

static const double TOLERANCE = 0.0001;

BOOST_AUTO_TEST_SUITE(SRPlaceDataTest)

BOOST_AUTO_TEST_CASE(testSelfCompatibility) {

	SRPlaceData original("test", 0.4, Timestamp());

	Location originalLoc(SRPlaceData::getTemplate(), SRPlaceData::getBaseTag());
	originalLoc = original;

	cout << originalLoc.getDocumentText(true) << endl;

	SRPlaceData parsed = extract<SRPlaceData>(originalLoc);

	BOOST_REQUIRE_EQUAL(original.getSrPlaceLabel(), parsed.getSrPlaceLabel());
	BOOST_REQUIRE_EQUAL(original.getSrPlaceConfidence(), parsed.getSrPlaceConfidence());

}

BOOST_AUTO_TEST_SUITE_END()
