#include <boost/test/unit_test.hpp>
#include <boost/test/floating_point_comparison.hpp>

#include <iostream>

#include "btl/StateChangeRequest.h"
#include "utils.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

static const double tolerance = 0.0001;

BOOST_AUTO_TEST_SUITE(StateChangeRequestTest)

BOOST_AUTO_TEST_CASE(testSelfCompatibility) {

	try {

		StateChangeRequest original;
		original.setGenerator("test123321");
		original.setTimestamp(Timestamp(123, 456));
		original.setNewStateName("TestName");

		Location originalLoc(StateChangeRequest::getTemplate(), StateChangeRequest::getBaseTag());
		BOOST_TEST_MESSAGE(originalLoc.getDocumentText(true));
		originalLoc = original;

		cout << originalLoc.getDocumentText(true);

		StateChangeRequest parsed = extract<StateChangeRequest>(originalLoc);

		BOOST_REQUIRE_EQUAL(parsed.getGenerator(), original.getGenerator());
		BOOST_REQUIRE_EQUAL(parsed.getTimestamp(), original.getTimestamp());
		BOOST_REQUIRE_EQUAL(parsed.getNewStateName(), original.getNewStateName());

	} catch (std::exception e) {
		BOOST_FAIL(string("Caught exception: ") + e.what());
	}

}

BOOST_AUTO_TEST_SUITE_END()
