/*
 * MovementDataTest.cpp
 *
 *  Created on: Jul 20, 2009
 *      Author: jwienke
 */

#include <boost/test/unit_test.hpp>
#include <boost/test/floating_point_comparison.hpp>

#include <iostream>

#include <sys/time.h>
#include <time.h>

#include "btl/Timestamp.h"

using namespace airobots;
using namespace std;
using namespace xmltio;

static const double TOLERANCE = 0.0001;

BOOST_AUTO_TEST_SUITE(TimestampTest)

BOOST_AUTO_TEST_CASE(testSelfCompatibility) {

	try {

		Timestamp original(3245345, 42);

		Location originalLoc(Timestamp::getTemplate(), Timestamp::getBaseTag());
		originalLoc = original;

		Timestamp parsed = extract<Timestamp>(originalLoc);

		BOOST_REQUIRE_EQUAL(parsed.getInserted(), original.getInserted());
		BOOST_REQUIRE_EQUAL(parsed.getUpdated(), original.getUpdated());

	} catch (std::exception e) {
		BOOST_FAIL(string("Caught exception: ") + e.what());
	}

}

BOOST_AUTO_TEST_SUITE_END()
