/**
 * A simple example that shows how to reuse xml locations to preserve other
 * attributes.
 */

#include <iostream>

#include <xmltio/xmltio.hpp>

#include "btl/NavigationGoalData.h"

using namespace std;
using namespace airobots;
using namespace xmltio;

int main(int argc, char **argv) {

	NavigationGoalData original("test", 230.34, -120, 0.623, 3.45, 0.2,
			NavigationGoalData::GLOBAL);
	original.setTimestamp(Timestamp(123, 456));

	Location loc(NavigationGoalData::getTemplate(),
			NavigationGoalData::getBaseTag());
	loc = original;

	loc["dummyattrib"] = 23;
	Location additionalElement("<IAMLEGEND/>", "IAMLEGEND");
	loc.add(additionalElement);

	cout << "--- Document after initial serialization and changes ---" << endl
			<< loc.getDocumentText(true);

	cout << "--- Changing navigation goal and reserializing it to the same location ---" << endl;

	original.setDR(0);
	original.setDTheta(0);
	original.setX(1);
	original.setY(2);
	original.setTheta(0.3);

	loc = original;

	cout << "--- Document after goal changes ---" << endl
				<< loc.getDocumentText(true);

	return 0;

}

