package de.unibi.airobots.btl.data;

import de.unibi.airobots.btl.common.ElementParser;
import nu.xom.Element;
import nu.xom.Nodes;

/**
 * Domain class representing the result of a goalReached query.
 * 
 * @author lschilli
 * @author jwienke
 */
public class GoalReachedData extends Type {

	private boolean stopped;

	public boolean isStopped() {
		return stopped;
	}

	public void setStopped(boolean stopped) {
		this.stopped = stopped;
	}

	public static String getBaseTag() {
		return "GOALREACHED";
	}

	public static void fromElement(Element element, GoalReachedData type) {

		Type.fromElement(element, type);

		Nodes nodes = element.query("REACHED");
		if (nodes.size() > 0) {
			Element elem = (Element) nodes.get(0);
			type.setStopped("1".equals(ElementParser.getTagValue(elem)));
		}

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void fillInto(Element parent) {
		
		super.fillInto(parent);

		Element reachedElement = new Element("REACHED");
		parent.appendChild(reachedElement);

		String reachedString = "0";
		if (isStopped()) {
			reachedString = "1";
		}
		reachedElement.appendChild(reachedString);

	}

}
