package de.unibi.airobots.btl.data.annotation;

/**
 * 
 * @author jhelbach
 */
public class MapPoint {

	private double x;
	
	private double y;
	
	private MapPoint.Kind kind;
	
	private MapPoint.Unit unit;
	
	private String ref;
	
	
	public MapPoint(double x, double y) {
		this.x = x;
		this.y = y;
		ref = "";
		kind = Kind.WORLD;
		unit = Unit.M;
	}
	
	public MapPoint(double x, double y, Kind kind, Unit unit, String ref) {
		super();
		this.x = x;
		this.y = y;
		this.kind = kind;
		this.unit = unit;
		this.ref = ref;
	}

	
	public MapPoint(MapPoint p) {
		this.x = p.getX();
		this.y = p.getY();
		this.kind = p.getKind();
		this.unit = p.getUnit();
		this.ref = p.getRef();
	}

	public double getX() {
		return x;
	}

	public void setX(double x) {
		this.x = x;
	}

	public double getY() {
		return y;
	}

	public void setY(double y) {
		this.y = y;
	}

	public MapPoint.Kind getKind() {
		return kind;
	}

	public void setKind(MapPoint.Kind kind) {
		this.kind = kind;
	}

	public MapPoint.Unit getUnit() {
		return unit;
	}

	public void setUnit(MapPoint.Unit unit) {
		this.unit = unit;
	}

	public String getRef() {
		return ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	public enum Unit {
		M, 
		CM, 
		MM,
		NM
	}

	public enum Kind {
		WORLD, 
		RELATIVE
	}
	
}
