package de.unibi.airobots.btl.data.speechrec;

import java.util.ArrayList;


/**
 * Domain class representing a non terminal symbol within the grammartree of
 * an utterance
 * 
 * @author lschilli
 */
public class GrammarNonTerminal implements GrammarSymbol {

	private String name;
	private ArrayList<GrammarSymbol> subsymbols = new ArrayList<GrammarSymbol>();

	public GrammarNonTerminal() {

	}

	GrammarNonTerminal(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public GrammarSymbol getSymbol(int index) {
		return subsymbols.get(index);
	}

	public int size() {
		return subsymbols.size();
	}

	public void addSymbol(GrammarSymbol sym) {
		subsymbols.add(sym);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		StringBuilder strb = new StringBuilder();
		strb.append(name + ":\n");
		for (int i = 0; i < subsymbols.size(); i++) {
			GrammarSymbol sym = subsymbols.get(i);
			strb.append(sym + "\n");
		}
		return strb.toString();
	}
}