package de.unibi.airobots.btl.common;

import static org.junit.Assert.*;

import org.junit.Test;

import nu.xom.Element;

import de.unibi.airobots.btl.common.Point3D.Scope;
import de.unibi.airobots.btl.units.LengthUnit;

/**
 * Test cases for {@link Type}.
 * 
 * @author lziegler
 */
public class Point3DTest {

	@Test
	public void selfCompatibility() throws Exception {

		Point3D p0 = new Point3D(1, 2, 3, LengthUnit.MILLIMETER, Scope.GLOBAL);
		Point3D p1 = new Point3D(1, 2, 3, LengthUnit.MILLIMETER, Scope.GLOBAL);
		Point3D p2 = new Point3D(0.1, 0.2, 0.3, LengthUnit.MILLIMETER, Scope.LOCAL);

		assertTrue("equals() not working", p0.equals(p1));
		assertTrue("equals() not working", p1.equals(p0));

		assertFalse("equals() not working", p1.equals(p2));

		assertEquals("Conversion not working", p2.getX(LengthUnit.MILLIMETER),
				p2.getX(LengthUnit.METER) * 1000, 0.00001);
		assertEquals("Conversion not working", p2.getY(LengthUnit.MILLIMETER),
				p2.getY(LengthUnit.METER) * 1000, 0.00001);
		assertEquals("Conversion not working", p2.getZ(LengthUnit.MILLIMETER),
				p2.getZ(LengthUnit.METER) * 1000, 0.00001);
		assertEquals("Conversion not working", p2.getX(LengthUnit.MILLIMETER),
				p2.getX(LengthUnit.CENTIMETER) * 10, 0.00001);
		assertEquals("Conversion not working", p2.getY(LengthUnit.MILLIMETER),
				p2.getY(LengthUnit.CENTIMETER) * 10, 0.00001);
		assertEquals("Conversion not working", p2.getZ(LengthUnit.MILLIMETER),
				p2.getZ(LengthUnit.CENTIMETER) * 10, 0.00001);

		Element element = new Element(Point3D.getBaseTag());
		p0.fillInto(element);

		Point3D p3 = Point3D.fromElement(element);

		assertTrue("serializing not working", p0.equals(p3));
	}
}
