package de.unibi.airobots.btl.common;

import static org.junit.Assert.*;
import nu.xom.Element;

import org.junit.Test;

import de.unibi.airobots.btl.units.LengthUnit;

/**
 * Test cases for {@link Type}.
 * 
 * @author lziegler
 */
public class PrecisePolygonTest {

	@Test
	public void selfCompatibility() throws Exception {

		PrecisePolygon p0 = new PrecisePolygon();
		p0.addPoint(0, 0, LengthUnit.MILLIMETER);
		p0.addPoint(2, 0, LengthUnit.MILLIMETER);
		p0.addPoint(0, 2, LengthUnit.MILLIMETER);

		PrecisePolygon p1 = new PrecisePolygon();
		p1.addPoint(0, 0, LengthUnit.MILLIMETER);
		p1.addPoint(2, 0, LengthUnit.MILLIMETER);

		assertFalse("equals() not working", p0.equals(p1));
		assertFalse("equals() not working", p1.equals(p0));

		p1.addPoint(0, 2, LengthUnit.MILLIMETER);

		assertTrue("equals() not working", p0.equals(p1));
		assertTrue("equals() not working", p1.equals(p0));

		p1.addPoint(0, 3, LengthUnit.MILLIMETER);

		assertFalse("equals() not working", p0.equals(p1));
		assertFalse("equals() not working", p1.equals(p0));

		Element element = new Element(PrecisePolygon.getBaseTag());
		p0.fillInto(element);
		PrecisePolygon p2 = PrecisePolygon.fromElement(element);

		assertTrue("serializing not working", p0.equals(p2));
	}
}
