package de.unibi.airobots.btl.data;

import static org.junit.Assert.*;
import nu.xom.Builder;
import nu.xom.Document;

import org.apache.log4j.Logger;
import org.junit.Test;

import de.unibi.airobots.btl.TestUtils;
import de.unibi.airobots.btl.common.Timestamp;

/**
 * Test cases for {@link Type}.
 * 
 * @author jwienke
 */
public class ImageDataTest {

	private Logger logger = Logger.getLogger(getClass());

	@Test
	public void fileCompatibility() throws Exception {

		Builder parser = new Builder();
		Document doc = parser.build(TestUtils
				.makeTestFileName("ImageData.xml"));

		ImageData parsed = new ImageData();
		ImageData.fromElement(doc.getRootElement(), parsed);
		assertEquals(doc.getRootElement().getLocalName(), ImageData
				.getBaseTag());

		assertEquals(new Timestamp(215815152l), parsed
				.getTimestamp());
		assertEquals(320, parsed.getWidth());
		assertEquals(240, parsed.getHeight());
		assertEquals("rgb", parsed.getColorspace());

	}

}
