package de.unibi.airobots.btl.data;

import static org.junit.Assert.*;
import nu.xom.Document;
import nu.xom.Element;

import org.apache.log4j.Logger;
import org.junit.Test;

public class StateChangeRequestTest {

	private Logger logger = Logger.getLogger(getClass());

	@Test
	public void selfCompatibility() throws Exception {

		StateChangeRequest original = new StateChangeRequest();
		final long timestamp = System.currentTimeMillis();
		original.setTimestamp(timestamp);
		original.setGenerator("test");
		original.setNewStateName("lub asdä#0ß");

		Document doc = new Document(new Element(SpeedData.getBaseTag()));
		original.fillInto(doc.getRootElement());
		logger.info(doc.toXML());

		StateChangeRequest parsed = new StateChangeRequest();
		StateChangeRequest.fromElement(doc.getRootElement(), parsed);

		assertEquals(original.getGenerator(), parsed.getGenerator());
		assertEquals(original.getTimestamp(), parsed.getTimestamp());
		assertEquals(original.getNewStateName(), parsed.getNewStateName());

	}

}
